#include "Trie.h"
#include <string>
#include <iostream>
#include <vector>
#include <fstream>

int main() {
	Trie<int> *trie = new Trie<int>(ALPHABET_SIZE);
	std::vector<std::string> words;
	std::ofstream out_search;
	std::ofstream out_remove;
	std::ofstream out_bonus;
	out_search.open("Ref/Lab11/task1.out");
	out_remove.open("Ref/Lab11/task2.out");
	out_bonus.open("Ref/Lab11/bonus1.out");
	std::string s;
	s = "arta";
	trie -> insert(s, 1);
	s = "artilerie";
	trie -> insert(s, 2);
	s = "artist";
	trie -> insert(s, 3);
	s = "artistic";
	trie -> insert(s, 4);
	s = "arma";
	trie -> insert(s, 5);
	s = "pusca";
	trie -> insert(s, 6);
	
	int val;
	if (!trie -> search(s, val)) {
		out_search << s << " should be in Trie\n";
	}
	out_search << "Value of " << s << " : " << val << std::endl;
	s = "artistic";
	if (!trie -> search(s, val)) {
		out_search << s << " should be in Trie\n";
	}
	out_search << "Value of " << s << " : " << val << std::endl;
	s = "artist";
	if (!trie -> search(s, val)) {
		out_search << s << " should be in Trie\n";
	}
	out_search << "Value of " << s << " : " << val << std::endl;
	s = "artilerie";
	if (!trie -> search(s, val)) {
		out_search << s << " should be in Trie\n";
	}
	out_search << "Value of " << s << " : " << val << std::endl;
	s = "arma";
	if (!trie -> search(s, val)) {
		out_search << s << " should be in Trie\n";
	}
	out_search << "Value of " << s << " : " << val << std::endl;
	s = "arta";
	if (!trie -> search(s, val)) {
		out_search << s << " should be in Trie\n";
	}
	out_search << "Value of " << s << " : " << val << std::endl;
	s = "artis";
	if (trie -> search(s, val)) {
		out_search << s << " should not be in Trie\n";
	}
	s = "pusca";
	trie -> remove(s);
	if (trie -> search(s, val)) {
		out_remove << s << " should not be in Trie after removal\n";
	}
	s = "artilerie";
	trie -> remove(s);
	if (trie -> search(s, val)) {
		out_remove << s << " should not be in Trie after removal\n";
	}
	s = "arta";
	if (!trie -> search(s, val)) {
		out_remove << s << " should still be in Trie\n";
	}
	s = "artist";
	trie -> remove(s);
	if (trie -> search(s, val)) {
		out_remove << s << " should not be in Trie after removal\n";
	}
	s = "artistic";
	if (!trie -> search(s, val)) {
		out_remove << s << " should still be in Trie\n";
	}
	s = "artist";
	trie -> insert(s, 3);
	s = "artilerie";
	trie -> insert(s, 3);
	s = "pusca";
	trie -> insert(s, 3);
	s = "";
	out_bonus << trie->numWordsWithPrefix(s) << std::endl;
	s = "a";
	out_bonus << trie->numWordsWithPrefix(s) << std::endl;
	s = "art";
	out_bonus << trie->numWordsWithPrefix(s) << std::endl;
	s = "arti";
	out_bonus << trie->numWordsWithPrefix(s) << std::endl;
	s = "articulatie";
	out_bonus << trie->numWordsWithPrefix(s) << std::endl;
	
	return 0;
}
